// 212_1.cpp:   .

#include "stdafx.h"
#include <stdio.h>

using namespace System;
using namespace System::Runtime::InteropServices;

#pragma unmanaged
//  ,    unmanaged-, 
//    (native) ,   
//     (),  
//       
//      

void NativeTakesAString (const char* p) 
{
	printf("(native) received '%s'\n", p);
}
 
#pragma managed
//  ,    managed-, 
//    CLR,     
//     (),   
//        CLR  
//  o    

int main()
{
	String^ s = gcnew String("sample string");
	IntPtr ip = Marshal::StringToHGlobalAnsi(s);
	//     s     
	//        IntPtr. 
	//    void, ..    
	//     
	
	const char* str = static_cast<const char*>(ip.ToPointer());
	//  :    native- char*  
	//   static_cast <type-id> (expression). 
	//   str  char    
	//      s. 
	// .. s - ,    str   
	// const,   ,  ,   
	//  ,  

	Console::WriteLine("(managed) passing string...");
	// ..    managed- main(),   
	//    WriteLine()
	
	// native-  managed-
	NativeTakesAString( str ); 
 
	Marshal::FreeHGlobal( ip );
	//    ,  
	// StringToHGlobalAnsi(s):    
	// ,     

	Console::ReadLine();
}
